# coding: utf-8

require 'gtk2'

#===============================================================================
#
#	Class: LegacyGraphics
#
class LegacyGraphics

	@@color = Array[
		@@black   = Gdk::Color.new(    0,     0,     0),
		@@blue    = Gdk::Color.new(    0,     0, 65535),
		@@red     = Gdk::Color.new(65535,     0,     0),
		@@magenta = Gdk::Color.new(65535,     0, 65535),
		@@green   = Gdk::Color.new(    0, 65535,     0),
		@@cyan    = Gdk::Color.new(    0, 65535, 65535),
		@@yellow  = Gdk::Color.new(65535, 65535,     0),
		@@white   = Gdk::Color.new(65535, 65535, 65535),
	]
	@@colormap = Gdk::Colormap.system
	@@color.each {|c| @@colormap.alloc_color(c, false, true) }

	def initialize(h_dmy, w_dmy, y_dmy, x_dmy, gy = 400, gx = 640, cy = 16, cx = 8, c = 0)
		@lx = 0
		@ly = 0

		@window = Gtk::Window.new
		@window.signal_connect('destroy') { Gtk.main_quit }
		@window.title = 'TrueLegacyGraphicsGtk2'
		@window.set_size_request(gx, gy)
		@window.set_app_paintable(true)
		@window.realize

		# http://ruby-gnome2.sourceforge.jp/hiki.cgi?Gdk%3A%3ADrawable
		@drawable = @window.window
		@gc = Gdk::GC.new(@drawable)

		@draw_procs = []
		fill(0, 0, gx - 1, gy - 1, c)
	end

	def pset(x, y, c)

		fill(x, y, x, y, c)
	end

	def locate(x, y)
	end

	def print(mes)
	end

	def line(x1, y1, x2, y2, c, bf = '', w = 1, d = nil, a = nil)
		if(bf =~ /f/i)
			fill(x1, y1, x2, y2, c)
		elsif(bf =~ /b/i)
			# not implement yet
		else
			@lx = x2
			@ly = y2
			_line(x1, y1, x2, y2, c, w, d, a)
		end
	end

	def cline(x, y, c, w = 1, d = nil, a = nil)
			  x1 = @lx
			  y1 = @ly
		@lx = x2 = x
		@ly = y2 = y
		_line(x1, y1, x2, y2, c, w, d, a)
	end

	#---------------------------------------------------------------------------
	#
	#	_line
	#
	def _line(x1, y1, x2, y2, c, w, d, a)

		@draw_procs << Proc.new {
			@gc.set_foreground(@@color[c.class <= Numeric ? c : 7])
			@drawable.draw_line(@gc, x1, y1, x2, y2)
		}
		pset(x2, y2, c)
	end

	def circle(x, y, r, c)
		# not implement yet
	end

	def fill(x1, y1, x2, y2, c)

		@draw_procs << Proc.new {
			@gc.set_foreground(@@color[c.class <= Numeric ? c : 7])
			@drawable.draw_rectangle(@gc, true, x1, y1, x2 - x1 + 1, y2 - y1 + 1)
		}
	end

	def text(x, y, s, c, f = 'Helvetica 10', a = 'center')

		@draw_procs << Proc.new {
			fontdesc = Pango::FontDescription.new
			fontdesc.set_family(f.split(/\s+/)[0])
			fontdesc.set_size(f.split(/\s+/)[1].to_i * Pango::SCALE)

			layout = Pango::Layout.new(@window.pango_context)
			layout.font_description = fontdesc
			layout.text = s

			@gc.set_foreground(@@color[c.class <= Numeric ? c : 7])
			@drawable.draw_layout(@gc, x, y, layout)
		}
	end

	def clear
	end

	def box(vchar_dmy, hchar_dmy)
	end

	def refresh
		@window.signal_connect('expose_event') {
			@draw_procs.each {|proc| proc.call }
		}
		@window.show_all
		Gtk.main
	end

	def close
	end
end
