#!/usr/bin/env ruby
# coding: utf-8

require './TrueLegacyGraphics'
#require './TrueLegacyGraphicsGtk2'

win = LegacyGraphics.new(nil, nil, nil, nil, 400, 640, nil, nil, 7)

# modern
fv_n = %w|1.4 - - 2 - - 2.8 - - 4 - - 5.6 - - 8 - - 11 - - 16 - - 22|
sv_n = %w|4 - - 8 - - 15 - - 30 - - 60 - - 125 - - 250 - - 500 - - 1000|

# leica
fv_l = %w|- - - - - - - - 3.5 - 4.5 - - 6.3 - - 9 - - 12.5 - - 18 - -|
sv_l = %w|- - - - - - - 20 - 30 40 - 60 - 100 - - 200 - - - 500 - - -|

fv = []; fv_n.each_index {|f| fv << (fv_n[f] == '-' ? fv_l[f] : fv_n[f]) }
sv = []; sv_n.each_index {|s| sv << (sv_n[s] == '-' ? sv_l[s] : sv_n[s]) }

oxx = (ox = 100) + (sx = 20) * (fv.size - 1)
oyy = (oy =  50) + (sy = 12) * (sv.size - 1)

fv.each_index {|y|	# 横線
	yy = oy + sy * y
	if(y % 3 == 0)
		win.line(ox, yy, oxx, yy, 0)
		win.text(ox - 20, yy, fv[y], 0)
	elsif(fv[y] != '-')
		win.line(ox, yy, oxx, yy, 0, '', 1, '. ')
		win.text(ox - 20, yy, fv[y], 0, 'Helvetica 7')
	end
}

sv.each_index {|x|	# 縦線
	xx = ox + sx * x
	if(x % 3 == 0)
		win.line(xx, oy, xx, oyy, 0)
		win.text(xx, oy - 5, sv[x], 0, 'Helvetica 10', 's')
	elsif(sv[x] != '-')
		win.line(xx, oy, xx, oyy, 0, '', 1, '. ')
		win.text(xx, oy - 5, sv[x], 0, 'Helvetica 7', 's')
	end
}

(0..8).each {|d|	# 斜線
	win.line(d * sx * 3 + ox, oy, ox, d * sy * 3 + oy, 0)
	win.text(ox + 52, d * sy * 3 + oy + 8, (d +  4).to_s, 0) unless(d == 8)
}
(0..8).each {|d|	# 斜線
	win.line(oxx, d * sy * 3 + oy, d * sx * 3 + ox, oyy, 0)
	win.text(oxx - 8, d * sy * 3 + oy + 8, (d + 11).to_s, 0) unless(d == 8)
}

win.refresh

__END__

